SystemOrganization addCategory: #FRP!

TestCase subclass: #FRPDefaultBehaviorTest
	instanceVariableNames: 'success'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP'!

!FRPDefaultBehaviorTest methodsFor: 'as yet unclassified' stamp: 'zz 5/14/2008 15:11'!
setUp
	super setUp.
	success := false! !

!FRPDefaultBehaviorTest methodsFor: 'as yet unclassified' stamp: 'zz 5/14/2008 15:11'!
succeeded
	success := true! !

!FRPDefaultBehaviorTest methodsFor: 'as yet unclassified' stamp: 'zz 5/14/2008 15:12'!
testABehaviorShouldTriggerAChangedValueEventWhenChanged
	| b |
	b := FRPDefaultBehavior new.
	b
		when: #changedValue
		send: #succeeded
		to: self.
	b behaviorValue: 1.
	self should:[success]! !

!FRPDefaultBehaviorTest methodsFor: 'as yet unclassified' stamp: 'zz 5/14/2008 15:29'!
testWhenABehaviorValueDoesNotChangeNoChangedValueEventIsTriggered
	| b |
	b := FRPDefaultBehavior new.
	b behaviorValue: 1.
	b behaviorValue: 1.
	b
		when: #changedValue
		send: #succeeded
		to: self.
	self should:[success not]! !

Morph subclass: #FRPTimer
	instanceVariableNames: 'state interval anyButtonPressed time'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP'!

!FRPTimer methodsFor: 'as yet unclassified' stamp: 'zz 5/16/2008 13:23'!
anyButtonPressed
	^ anyButtonPressed! !

!FRPTimer methodsFor: 'as yet unclassified' stamp: 'zz 5/16/2008 13:23'!
handlesMouseDown: event 
	^ true! !

!FRPTimer methodsFor: 'as yet unclassified' stamp: 'zz 5/16/2008 13:28'!
initialize
	super initialize.
	state := #stopped.
	interval := 1000.
	anyButtonPressed := false! !

!FRPTimer methodsFor: 'as yet unclassified' stamp: 'zz 5/14/2008 13:58'!
interval: anInterval 
	interval := anInterval! !

!FRPTimer methodsFor: 'as yet unclassified' stamp: 'zz 5/14/2008 13:58'!
isRunning
	^ state == #run! !

!FRPTimer methodsFor: 'as yet unclassified' stamp: 'zz 5/16/2008 13:23'!
mouseDown: anEvent 
	anEvent anyButtonPressed
		ifTrue: [anyButtonPressed := true]! !

!FRPTimer methodsFor: 'as yet unclassified' stamp: 'zz 5/14/2008 13:58'!
startTimer
	state := #run! !

!FRPTimer methodsFor: 'as yet unclassified' stamp: 'zz 5/16/2008 15:48'!
step
	self isRunning
		ifTrue: [time eventOccured]! !

!FRPTimer methodsFor: 'as yet unclassified' stamp: 'zz 5/14/2008 13:58'!
stepTime
	^ interval! !

!FRPTimer methodsFor: 'as yet unclassified' stamp: 'zz 5/14/2008 13:58'!
stopTimer
	state := #stopped! !

!FRPTimer methodsFor: 'as yet unclassified' stamp: 'zz 5/16/2008 15:47'!
time: anFRPTimeObject
time := anFRPTimeObject ! !

Object subclass: #FRPObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP'!

!FRPObject commentStamp: 'zz 5/16/2008 13:08' prior: 0!
FRPObjects handle events with MessageSend and not WeakMessageSend.!

FRPObject subclass: #FRPAbstractBehavior
	instanceVariableNames: 'behaviorValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP'!

!FRPAbstractBehavior methodsFor: 'as yet unclassified' stamp: 'zz 5/14/2008 14:26'!
behaviorValue
	^ behaviorValue! !

!FRPAbstractBehavior methodsFor: 'as yet unclassified' stamp: 'zz 5/14/2008 14:26'!
behaviorValue: aBehaviorValue 
	self subclassResponsibility! !

!FRPAbstractBehavior methodsFor: 'as yet unclassified' stamp: 'zz 5/14/2008 14:26'!
initialBehaviorValue: aValue 
	behaviorValue := aValue! !

!FRPAbstractBehavior methodsFor: 'as yet unclassified' stamp: 'zz 5/16/2008 15:31'!
lift1: aFunctionBlock 
	^ FRPLift1Behavior new behaviorValue: self;
		 functionBlock: aFunctionBlock! !

FRPAbstractBehavior subclass: #FRPConstantBehavior
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP'!

!FRPConstantBehavior commentStamp: 'zz 5/9/2008 11:39' prior: 0!
A Behavior whose value never changes!

!FRPConstantBehavior methodsFor: 'as yet unclassified' stamp: 'zz 5/14/2008 14:27'!
behaviorValue: aBehaviorValue

^ self shouldNotImplement! !

FRPAbstractBehavior subclass: #FRPDefaultBehavior
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP'!

!FRPDefaultBehavior methodsFor: 'as yet unclassified' stamp: 'zz 5/16/2008 13:09'!
behaviorValue: aValue 
	| client |
	aValue == behaviorValue
		ifFalse: [behaviorValue := aValue.
			client := self triggerEvent: #changedValue]! !

!FRPDefaultBehavior methodsFor: 'as yet unclassified' stamp: 'zz 5/13/2008 13:49'!
recomputeValue

	self subclassResponsibility! !

FRPDefaultBehavior subclass: #FRPLift1Behavior
	instanceVariableNames: 'behavior functionBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP'!

!FRPLift1Behavior methodsFor: 'as yet unclassified' stamp: 'zz 5/16/2008 15:11'!
behavior: aBehavior 
	behavior := aBehavior! !

!FRPLift1Behavior methodsFor: 'as yet unclassified' stamp: 'zz 5/16/2008 15:09'!
eventOccured
	self
		value: (functionBlock value: behavior behaviorValue)! !

!FRPLift1Behavior methodsFor: 'as yet unclassified' stamp: 'zz 5/16/2008 15:11'!
functionBlock: aBlock 
	functionBlock := aBlock! !

!FRPLift1Behavior methodsFor: 'as yet unclassified' stamp: 'zz 5/16/2008 15:11'!
recomputeValue
	behavior behaviorValue! !

FRPDefaultBehavior subclass: #FRPTime
	instanceVariableNames: 'timer samplingInterval'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP'!

!FRPTime methodsFor: 'as yet unclassified' stamp: 'zz 5/14/2008 14:27'!
eventOccured
	| scheduler |
	scheduler := FRPScheduler currentScheduler.
	scheduler beginInputStep.
	self behaviorValue: behaviorValue + (samplingInterval / 1000).
	scheduler endInputStep! !

!FRPTime methodsFor: 'as yet unclassified' stamp: 'zz 5/16/2008 15:47'!
initialize
	super initialize.
	timer := FRPTimer new.
	samplingInterval := 1000.
	behaviorValue := 0.
	timer interval: samplingInterval.
	timer time: self! !

!FRPTime methodsFor: 'as yet unclassified' stamp: 'zz 5/13/2008 13:50'!
recomputeValue
! !

!FRPTime methodsFor: 'as yet unclassified' stamp: 'zz 5/14/2008 10:08'!
start

	timer startTimer.
	timer openInHand ! !

!FRPTime methodsFor: 'as yet unclassified' stamp: 'zz 5/13/2008 15:01'!
stop

	timer stop! !

FRPObject subclass: #FRPAbstractEventSource
	instanceVariableNames: 'scheduler occurence cacheTimeStep'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP'!

!FRPAbstractEventSource classSide methodsFor: 'as yet unclassified' stamp: 'zz 5/13/2008 11:17'!
new

	^ super new scheduler: FRPScheduler currentScheduler! !

!FRPAbstractEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 14:27'!
-=> aValue
"Bind combinator"
	^ FRPBindEventSource eventSource: self bind: aValue! !

!FRPAbstractEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/16/2008 13:16'!
==> aBlock
! !

!FRPAbstractEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 14:11'!
event

	scheduler currentTimeStep ~= cacheTimeStep
		ifTrue: [occurence := nil.
			cacheTimeStep := scheduler currentTimeStep.
			self recomputeOccurence].
	^ occurence! !

!FRPAbstractEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 14:11'!
event: anEvent

	occurence := anEvent.
	cacheTimeStep := scheduler currentTimeStep.
	self triggerEvent: #FRPEventOccured with: self! !

!FRPAbstractEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 14:11'!
initialize

	occurence := nil.
	cacheTimeStep := -1! !

!FRPAbstractEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 14:11'!
recomputeOccurence

	self subclassResponsibility! !

!FRPAbstractEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/13/2008 11:16'!
scheduler: aScheduler


scheduler := aScheduler! !

FRPAbstractEventSource subclass: #FRPAbstractEventSourceListener
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP'!

!FRPAbstractEventSourceListener methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 14:42'!
eventOccured: anEvent

self subclassResponsibility! !

FRPAbstractEventSourceListener subclass: #FRPBindEventSource
	instanceVariableNames: 'eventSource bindValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP'!

!FRPBindEventSource classSide methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 14:25'!
eventSource: anEventSource bind:aBindValue

^(super new) eventSource: anEventSource; bindValue: aBindValue! !

!FRPBindEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 14:58'!
bindValue: aValue

	bindValue := aValue! !

!FRPBindEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 14:58'!
eventOccured: anEvent

	self
		event: (FRPObjectEvent withValue: bindValue)! !

!FRPBindEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 14:58'!
eventSource: anFRPSourceEvent

	eventSource := anFRPSourceEvent! !

!FRPBindEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 14:59'!
recomputeOccurence

	eventSource event! !

FRPAbstractEventSourceListener subclass: #FRPMergeEventSource
	instanceVariableNames: 'firstEventSource secondEventSource lastOccurenceTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP'!

!FRPMergeEventSource classSide methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 13:48'!
between: firstEventSource and: secondEventSource

^(super new) firstEventSource: firstEventSource; secondEventSource: secondEventSource! !

!FRPMergeEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 14:12'!
eventOccured: anEvent

	scheduler currentTimeStep = lastOccurenceTime
		ifTrue: [self error: 'EventMerge: got a simultaneous occurence in this time step (dropping occurnce)']
		ifFalse: [lastOccurenceTime := scheduler currentTimeStep.
			self event: anEvent]! !

!FRPMergeEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 14:09'!
firstEventSource: anEventSource

	firstEventSource := anEventSource.
	anEventSource
		when: #FRPEventOccured
		send: #eventOccured:
		to: self! !

!FRPMergeEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 14:09'!
initialize

	lastOccurenceTime := -1! !

!FRPMergeEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 14:09'!
recomputeOccurence

	firstEventSource event.
	secondEventSource event! !

!FRPMergeEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 14:12'!
secondEventSource: anEventSource

	secondEventSource := anEventSource.
	anEventSource
		when: #FRPEventOccured
		send: #eventOccured
		to: self! !

FRPAbstractEventSource subclass: #FRPAnyButtonPressedEventSource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP'!

!FRPAnyButtonPressedEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/16/2008 13:24'!
recomputeOccurence

	| timer |
	timer := FRPScheduler currentScheduler timer.
	timer anyButtonPressed 
		ifTrue: [occurence := true. Transcript show:'bip']
		ifFalse: [occurence := nil]! !

FRPAbstractEventSource subclass: #FRPLeftButtonPressedEventSource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP'!

!FRPLeftButtonPressedEventSource methodsFor: 'as yet unclassified' stamp: 'zz 5/13/2008 16:34'!
recomputeOccurence

	Transcript show:'I/O'.
	Sensor redButtonPressed
		ifTrue: [occurence := true]
		ifFalse: [occurence := nil]! !

FRPObject subclass: #FRPEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP'!

FRPEvent subclass: #FRPObjectEvent
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP'!

!FRPObjectEvent methodsFor: 'as yet unclassified' stamp: 'zz 5/9/2008 14:55'!
value

	^ value! !

FRPObject subclass: #FRPExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP'!

!FRPExample classSide methodsFor: 'as yet unclassified' stamp: 'zz 5/16/2008 15:54'!
example1
	"Just attach a watcher to a time instance"
	| time watcher |
	FRPScheduler initialize.
	time := FRPTime new.
	watcher := FRPWatcher new watch: time.
	time start! !

!FRPExample classSide methodsFor: 'as yet unclassified' stamp: 'zz 5/16/2008 15:55'!
example2
	| eventSource anyButtonPressed time |
	self flag: #doesNotWork.
	FRPScheduler initialize.
	anyButtonPressed := FRPAnyButtonPressedEventSource new.
	eventSource := anyButtonPressed -=> Color red.
	time := FRPTime new.
	time start! !

!FRPExample classSide methodsFor: 'as yet unclassified' stamp: 'zz 5/16/2008 15:55'!
example3
	| time sinBehavior |
	FRPScheduler initialize.
	time := FRPTime new.
	sinBehavior := time
				lift1: [:x | x sin * 100].
	time start! !

!FRPObject methodsFor: 'as yet unclassified' stamp: 'zz 5/16/2008 13:07'!
when: anEventSelector send: aMessageSelector to: anObject 
	self
		when: anEventSelector
		evaluate: (MessageSend receiver: anObject selector: aMessageSelector)! !

!FRPObject methodsFor: 'as yet unclassified' stamp: 'zz 5/16/2008 13:07'!
when: anEventSelector send: aMessageSelector to: anObject with: anArg 
	self
		when: anEventSelector
		evaluate: (MessageSend
				receiver: anObject
				selector: aMessageSelector
				arguments: (Array with: anArg))! !

FRPObject subclass: #FRPScheduler
	instanceVariableNames: 'currentTimeStep numberCalls'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP'!

FRPScheduler class
	instanceVariableNames: 'currentScheduler'!

FRPScheduler class
	instanceVariableNames: 'currentScheduler'!

!FRPScheduler classSide methodsFor: 'as yet unclassified' stamp: 'zz 5/13/2008 11:13'!
currentScheduler
	"singleton"
	currentScheduler isNil
		ifTrue: [currentScheduler := FRPScheduler new].
	^ currentScheduler! !

!FRPScheduler classSide methodsFor: 'as yet unclassified' stamp: 'zz 5/14/2008 13:59'!
example2
	"Just attach a watcher to a time instance"
	| time watcher |
	time := FRPTime new.
	watcher := FRPWatcher new watch: time.
	time start.
	^ time! !

!FRPScheduler classSide methodsFor: 'as yet unclassified' stamp: 'zz 5/16/2008 15:54'!
initialize

super initialize.
currentScheduler := nil! !

!FRPScheduler methodsFor: 'as yet unclassified' stamp: 'zz 5/16/2008 15:55'!
beginInputStep
	numberCalls = 0
		ifTrue: [currentTimeStep := currentTimeStep + 1].
	numberCalls := numberCalls + 1! !

!FRPScheduler methodsFor: 'as yet unclassified' stamp: 'zz 5/14/2008 14:29'!
currentTimeStep
	^ currentTimeStep! !

!FRPScheduler methodsFor: 'as yet unclassified' stamp: 'zz 5/14/2008 14:29'!
endInputStep
	numberCalls := numberCalls - 1! !

!FRPScheduler methodsFor: 'as yet unclassified' stamp: 'zz 5/13/2008 10:56'!
initialize

currentTimeStep := 0.
numberCalls := 0! !

!FRPScheduler methodsFor: 'as yet unclassified' stamp: 'zz 5/13/2008 10:56'!
start

self beginInputStep.
self endInputStep! !

FRPObject subclass: #FRPWatcher
	instanceVariableNames: 'watch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FRP'!

!FRPWatcher methodsFor: 'as yet unclassified' stamp: 'zz 5/16/2008 13:02'!
eventOccured
	Transcript show: 'Watcher: Behavior changed'! !

!FRPWatcher methodsFor: 'as yet unclassified' stamp: 'zz 5/16/2008 13:03'!
watch: aBehavior 

	watch := aBehavior.
	aBehavior
		when: #changedValue
		send: #eventOccured
		to: self! !
FRPScheduler initialize!
